# -*- coding: UTF-8 -*-
from mod.server.system.serverSystem import ServerSystem
from mod.common.minecraftEnum import ItemPosType, AttrType
from mod.server.serverEvent import ServerEvent
import mod.server.extraServerApi as serverApi


class Main(ServerSystem):

    def __init__(self, namespace, system_name):
        ServerSystem.__init__(self, namespace, system_name)
        namespace, system = serverApi.GetEngineNamespace(), serverApi.GetEngineSystemName()
        self.ListenForEvent(namespace, system, ServerEvent.ServerChatEvent, self, self.equipment_chat)
        self.ListenForEvent(namespace, system, ServerEvent.PlayerAttackEntityEvent, self, self.equipment_attack)

    # 获取玩家聊天信息
    def equipment_chat(self, event):
        msg = event['message']
        player_id = event['playerId']
        # 匹配聊天内容
        if msg == '吸血剑':
            item_comp = serverApi.GetEngineCompFactory().CreateItem(player_id)
            # 生成自定义词缀的钻石剑
            item_comp.SpawnItemToPlayerCarried(
                {
                    'itemName': 'minecraft:diamond_sword',
                    'count': 1,
                    'customTips': '%name%%category%\n吸血属性:单次伤害恢复玩家一颗心\n%enchanting%%attack_damage%'
                },
                player_id
            )

    def equipment_attack(self, event):
        player_id = event['playerId']
        item_comp = serverApi.GetEngineCompFactory().CreateItem(player_id)
        item_dict = item_comp.GetPlayerItem(ItemPosType.CARRIED)
        # 匹配词缀数据是否包含吸血
        if item_dict and '吸血' in item_dict['customTips']:
            attr_comp = serverApi.GetEngineCompFactory().CreateAttr(player_id)
            # 获得玩家当前生命值
            current_health = attr_comp.GetAttrValue(AttrType.HEALTH)
            # 设置玩家生命值，其中min(参数1，参数2)的意思为取两个数字的最小值
            attr_comp.SetAttrValue(AttrType.HEALTH, min(current_health + 1, 20))